\section{Projects}
\label{sec:projects}

\subsection{Project management}
\label{subsec:project-management}

Each and everyone of the projects I was involved was born due to at least one
of the following causes:
\begin{itemize}
    \item tecnical issue
    \item \fs{} or \fsae{} rules car did not comply to
    \item feature request
    \item experiment to improve something
\end{itemize}
Many of the projects failed. A few were successful, only this was important. It
is important to note that in such a fast and risky field, such as the \fs{} world,
you have to experiment something many times in order to find a solution (or the
best one). In theory everything works because you can take into account every kind
of hypothesis you want. In practice you have to struggle with other 30 people doing
many other things on the same car: you have to come to terms with it.

\subsection{BMS}
\label{subsec:bms}

Long story short:
\begin{enumerate}
    \item for the last 3 years we've trying to develop our own BMS. It is difficult
    to achieve a good working product since it has to be reliable at all times.
    \item we decided to buy a commercial solution (after a long decision process)
    and we weren't satisfied
    \item meanwhile we kept troubleshooting a new version of our own BMS.
    \item as soon as our own BMS worked, we switched to it (even if they were not
    100\% reliable)
\end{enumerate}

Our own BMS solution consists of 3 parts:
\begin{itemize}
    \item slave (24 of them), which takes raw measurements of the battery cells'
    voltage and temperature
    \item host, which acts as the master of the slaves
    \item connections between slaves and host (CAN bus)
\end{itemize}

\subsubsection{Host}
\label{subsubsec:bms-host}

I was involved in writing the BMS host code. We implemented a safety-first one-thread
Arduino program in an Arduino DUE. The following are some excerpts of the code.
\lstinputlisting[language=C++, caption=Implementation of balancing mode]{code/bms/host.cpp}

\subsubsection{Slave}
\label{subsubsec:bms-slave}

Regarding the slave, we implemented an event-driven (by CAN message) low-level
temperature and voltage reader. The followings are some of the low-level functions
we coded.
\lstinputlisting[language=C++, caption=Low-level functions]{code/bms/slave.cpp}

\subsection{Telemetry}
\label{subsec:telemetry}

Since 2017-18 we've been developing our own telemetry system in order to get an
idea of the status of the car and how to improve it. The main constraint of such
software is that it should run on every team member PC: that's why we coded it
in Java.
\lstinputlisting[language=Java, caption=YOLO Telemetry app]{code/telemetry/yolo.java}

\subsubsection{Data analysis}
\label{subsubsec:telemetry-data}

As for the analysis of the telemetry data, we exploited Python and implemented some
of the most used statistical functions to parse and analyze our data.
\lstinputlisting[language=Python, caption=Peeper data analysis tool]{code/telemetry/peeper.py}

\subsection{Control unit}
\label{subsec:control-unit}

Since the very start of the electric car project, we've been developing our own
control unit, based on the Texas Instruments Delfino. It was a very convenient
choice since it came with debugging tools and an IDE.
\lstinputlisting[language=C++, caption=CAN handling]{code/control-unit/ti.cpp}

\subsection{IMU}
\label{subsec:imu}

This season we were provided with an Ellipse-2N IMU which unfortunately did not
integrate with our current sensor configuration. We did many tests on the issue
but came up with the only solution of using 2 CAN lines.
\lstinputlisting[language=C++, caption=IMU reading in TI]{code/imu/ti.cpp}

\subsection{Torque vectoring}
\label{subsec:torque-vectoring}

Had we had available the IMU reading we could have implemented and used the TV
devised by the Vehicle Performance team. Instead we used the steering-based version.
\lstinputlisting[language=C++, caption=TV based on steering]{code/tv/steering.cpp}

\subsection{Steering wheel}
\label{subsec:steering-wheel}

We solved a few bugs on the steering wheel code from the previous year. We kept the
interrupt-based system.
\lstinputlisting[language=C++, caption=Interrupts on steering wheel]{code/steering/interrupts.cpp}

\subsection{Yentl}
\label{subsec:yentl}

In order to easy the testing process we have devised an automated web-based \fs{}
questions testing app called Yentl, after the Barbra Streisand movie.
\lstinputlisting[language=JavaScript, caption=YENTL]{code/yentl/app.js}
